package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.WFStep;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class WFStepSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<WFStep> selectCond;
	private JSONObject customsearchval;
	public WFStepSearchFilter(){
		this.page =new Page<WFStep>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<WFStep>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_wfinstanceid_eq;

	public void setN_wfinstanceid_eq(String n_wfinstanceid_eq) {
        this.n_wfinstanceid_eq = n_wfinstanceid_eq;
        if(!StringUtils.isEmpty(this.n_wfinstanceid_eq)){
            this.selectCond.eq("wfinstanceid", n_wfinstanceid_eq);
        }
    }
	private String n_wfinstancename_eq;

	public void setN_wfinstancename_eq(String n_wfinstancename_eq) {
        this.n_wfinstancename_eq = n_wfinstancename_eq;
        if(!StringUtils.isEmpty(this.n_wfinstancename_eq)){
            this.selectCond.eq("wfinstancename", n_wfinstancename_eq);
        }
    }
	private String n_wfinstancename_like;

	public void setN_wfinstancename_like(String n_wfinstancename_like) {
        this.n_wfinstancename_like = n_wfinstancename_like;
        if(!StringUtils.isEmpty(this.n_wfinstancename_like)){
            this.selectCond.like("wfinstancename", n_wfinstancename_like);
        }
    }
	private String n_wfplogicname_like;

	public void setN_wfplogicname_like(String n_wfplogicname_like) {
        this.n_wfplogicname_like = n_wfplogicname_like;
        if(!StringUtils.isEmpty(this.n_wfplogicname_like)){
            this.selectCond.like("wfplogicname", n_wfplogicname_like);
        }
    }
	private String n_wfstepname_like;

	public void setN_wfstepname_like(String n_wfstepname_like) {
        this.n_wfstepname_like = n_wfstepname_like;
        if(!StringUtils.isEmpty(this.n_wfstepname_like)){
            this.selectCond.like("wfstepname", n_wfstepname_like);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_WFSTEP_WFINSTANCE_WFINSTANCEID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_wfinstanceid_eq("NA");
			}
			else{
				this.setN_wfinstanceid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("wfstepname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}